Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 2893)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 2894)
@@ -8133,310 +8169,274 @@
     INTEGER(iwp) ::  nysf            !< 
     INTEGER(iwp) ::  nys_on_file     !< 
-    INTEGER(iwp) ::  overlap_count   !< 
-
-    INTEGER(iwp), DIMENSION(numprocs_previous_run,1000) ::  nxlfa       !< 
-    INTEGER(iwp), DIMENSION(numprocs_previous_run,1000) ::  nxrfa       !< 
-    INTEGER(iwp), DIMENSION(numprocs_previous_run,1000) ::  nynfa       !< 
-    INTEGER(iwp), DIMENSION(numprocs_previous_run,1000) ::  nysfa       !< 
-    INTEGER(iwp), DIMENSION(numprocs_previous_run,1000) ::  offset_xa   !< 
-    INTEGER(iwp), DIMENSION(numprocs_previous_run,1000) ::  offset_ya   !< 
-
-    REAL(wp),                                                                  &
-       DIMENSION(nys_on_file-nbgp:nyn_on_file+nbgp,nxl_on_file-nbgp:nxr_on_file+nbgp) ::&
-          tmp_2d   !< 
-
-    REAL(wp),                                                                  &
-       DIMENSION(nzb:nzt+1,nys_on_file-nbgp:nyn_on_file+nbgp,nxl_on_file-nbgp:nxr_on_file+nbgp) ::&
-          tmp_3d   !< 
-
-    REAL(wp),                                                                  &
-       DIMENSION(0:0,nys_on_file-nbgp:nyn_on_file+nbgp,nxl_on_file-nbgp:nxr_on_file+nbgp) ::&
-          tmp_3d2   !< 
-
-
-
-   IF ( initializing_actions == 'read_restart_data' )  THEN
-      READ ( 13 )  field_char
-
-      DO  WHILE ( TRIM( field_char ) /= '*** end rad ***' )
-
-         DO  k = 1, overlap_count
-
-            nxlf = nxlfa(i,k)
-            nxlc = nxlfa(i,k) + offset_xa(i,k)
-            nxrf = nxrfa(i,k)
-            nxrc = nxrfa(i,k) + offset_xa(i,k)
-            nysf = nysfa(i,k)
-            nysc = nysfa(i,k) + offset_ya(i,k)
-            nynf = nynfa(i,k)
-            nync = nynfa(i,k) + offset_ya(i,k)
-
-
-            SELECT CASE ( TRIM( field_char ) )
-
-                CASE ( 'rad_net_av' )
-                   IF ( .NOT. ALLOCATED( rad_net_av ) )  THEN
-                      ALLOCATE( rad_net_av(nysg:nyng,nxlg:nxrg) )
-                   ENDIF  
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   rad_net_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  =      &
-                                 tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-                CASE ( 'rad_lw_in' )
-                   IF ( .NOT. ALLOCATED( rad_lw_in ) )  THEN
-                      IF ( radiation_scheme == 'clear-sky'  .OR.               &
-                           radiation_scheme == 'constant')  THEN
-                         ALLOCATE( rad_lw_in(0:0,nysg:nyng,nxlg:nxrg) )
-                      ELSE
-                         ALLOCATE( rad_lw_in(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                      ENDIF
-                   ENDIF  
-                   IF ( k == 1 )  THEN
-                      IF ( radiation_scheme == 'clear-sky'  .OR.               &
-                           radiation_scheme == 'constant')  THEN
-                         READ ( 13 )  tmp_3d2
-                         rad_lw_in(0:0,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =&
-                            tmp_3d2(0:0,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-                      ELSE
-                         READ ( 13 )  tmp_3d
-                         rad_lw_in(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =&
-                             tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-                      ENDIF
-                   ENDIF
-
-                CASE ( 'rad_lw_in_av' )
-                   IF ( .NOT. ALLOCATED( rad_lw_in_av ) )  THEN
-                      IF ( radiation_scheme == 'clear-sky'  .OR.               &
-                           radiation_scheme == 'constant')  THEN
-                         ALLOCATE( rad_lw_in_av(0:0,nysg:nyng,nxlg:nxrg) )
-                      ELSE
-                         ALLOCATE( rad_lw_in_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                      ENDIF
-                   ENDIF  
-                   IF ( k == 1 )  THEN
-                      IF ( radiation_scheme == 'clear-sky'  .OR.               &
-                           radiation_scheme == 'constant')  THEN
-                         READ ( 13 )  tmp_3d2
-                         rad_lw_in_av(0:0,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =&
-                             tmp_3d2(0:0,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-                      ELSE
-                         READ ( 13 )  tmp_3d
-                         rad_lw_in_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =&
-                             tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-                      ENDIF
-                   ENDIF
-
-                CASE ( 'rad_lw_out' )
-                   IF ( .NOT. ALLOCATED( rad_lw_out ) )  THEN
-                      IF ( radiation_scheme == 'clear-sky'  .OR.               &
-                           radiation_scheme == 'constant')  THEN
-                         ALLOCATE( rad_lw_out(0:0,nysg:nyng,nxlg:nxrg) )
-                      ELSE
-                         ALLOCATE( rad_lw_out(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                      ENDIF
-                   ENDIF  
-                   IF ( k == 1 )  THEN
-                      IF ( radiation_scheme == 'clear-sky'  .OR.               &
-                           radiation_scheme == 'constant')  THEN
-                         READ ( 13 )  tmp_3d2
-                         rad_lw_out(0:0,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =&
-                             tmp_3d2(0:0,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-                      ELSE
-                         READ ( 13 )  tmp_3d
-                         rad_lw_out(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =&
-                             tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-                      ENDIF
-                   ENDIF
-
-                CASE ( 'rad_lw_out_av' )
-                   IF ( .NOT. ALLOCATED( rad_lw_out_av ) )  THEN
-                      IF ( radiation_scheme == 'clear-sky'  .OR.               &
-                           radiation_scheme == 'constant')  THEN
-                         ALLOCATE( rad_lw_out_av(0:0,nysg:nyng,nxlg:nxrg) )
-                      ELSE
-                         ALLOCATE( rad_lw_out_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                      ENDIF
-                   ENDIF  
-                   IF ( k == 1 )  THEN
-                      IF ( radiation_scheme == 'clear-sky'  .OR.               &
-                           radiation_scheme == 'constant')  THEN
-                         READ ( 13 )  tmp_3d2
-                         rad_lw_out_av(0:0,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =&
-                             tmp_3d2(0:0,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-                      ELSE
-                         READ ( 13 )  tmp_3d
-                         rad_lw_out_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =&
-                             tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-                      ENDIF
-                   ENDIF
-
-                CASE ( 'rad_lw_cs_hr' )
-                   IF ( .NOT. ALLOCATED( rad_lw_cs_hr ) )  THEN
-                      ALLOCATE( rad_lw_cs_hr(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   ENDIF
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   rad_lw_cs_hr(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =   &
-                           tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'rad_lw_cs_hr_av' )
-                   IF ( .NOT. ALLOCATED( rad_lw_cs_hr_av ) )  THEN
-                      ALLOCATE( rad_lw_cs_hr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   ENDIF
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   rad_lw_cs_hr_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
-                           tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'rad_lw_hr' )
-                   IF ( .NOT. ALLOCATED( rad_lw_hr ) )  THEN
-                      ALLOCATE( rad_lw_hr(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   ENDIF
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   rad_lw_hr(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =      &
-                           tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'rad_lw_hr_av' )
-                   IF ( .NOT. ALLOCATED( rad_lw_hr_av ) )  THEN
-                      ALLOCATE( rad_lw_hr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   ENDIF
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   rad_lw_hr_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =   &
-                           tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'rad_sw_in' )
-                   IF ( .NOT. ALLOCATED( rad_sw_in ) )  THEN
-                      IF ( radiation_scheme == 'clear-sky'  .OR.               &
-                           radiation_scheme == 'constant')  THEN
-                         ALLOCATE( rad_sw_in(0:0,nysg:nyng,nxlg:nxrg) )
-                      ELSE
-                         ALLOCATE( rad_sw_in(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                      ENDIF
-                   ENDIF  
-                   IF ( k == 1 )  THEN
-                      IF ( radiation_scheme == 'clear-sky'  .OR.               &
-                           radiation_scheme == 'constant')  THEN
-                         READ ( 13 )  tmp_3d2
-                         rad_sw_in(0:0,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =&
-                             tmp_3d2(0:0,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-                      ELSE
-                         READ ( 13 )  tmp_3d
-                         rad_sw_in(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =&
-                             tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-                      ENDIF
-                   ENDIF
-
-                CASE ( 'rad_sw_in_av' )
-                   IF ( .NOT. ALLOCATED( rad_sw_in_av ) )  THEN
-                      IF ( radiation_scheme == 'clear-sky'  .OR.               &
-                           radiation_scheme == 'constant')  THEN
-                         ALLOCATE( rad_sw_in_av(0:0,nysg:nyng,nxlg:nxrg) )
-                      ELSE
-                         ALLOCATE( rad_sw_in_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                      ENDIF
-                   ENDIF  
-                   IF ( k == 1 )  THEN
-                      IF ( radiation_scheme == 'clear-sky'  .OR.               &
-                           radiation_scheme == 'constant')  THEN
-                         READ ( 13 )  tmp_3d2
-                         rad_sw_in_av(0:0,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =&
-                             tmp_3d2(0:0,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-                      ELSE
-                         READ ( 13 )  tmp_3d
-                         rad_sw_in_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =&
-                             tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-                      ENDIF
-                   ENDIF
-
-                CASE ( 'rad_sw_out' )
-                   IF ( .NOT. ALLOCATED( rad_sw_out ) )  THEN
-                      IF ( radiation_scheme == 'clear-sky'  .OR.               &
-                           radiation_scheme == 'constant')  THEN
-                         ALLOCATE( rad_sw_out(0:0,nysg:nyng,nxlg:nxrg) )
-                      ELSE
-                         ALLOCATE( rad_sw_out(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                      ENDIF
-                   ENDIF  
-                   IF ( k == 1 )  THEN
-                      IF ( radiation_scheme == 'clear-sky'  .OR.               &
-                           radiation_scheme == 'constant')  THEN
-                         READ ( 13 )  tmp_3d2
-                         rad_sw_out(0:0,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =&
-                             tmp_3d2(0:0,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-                      ELSE
-                         READ ( 13 )  tmp_3d
-                         rad_sw_out(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =&
-                             tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-                      ENDIF
-                   ENDIF
-
-                CASE ( 'rad_sw_out_av' )
-                   IF ( .NOT. ALLOCATED( rad_sw_out_av ) )  THEN
-                      IF ( radiation_scheme == 'clear-sky'  .OR.               &
-                           radiation_scheme == 'constant')  THEN
-                         ALLOCATE( rad_sw_out_av(0:0,nysg:nyng,nxlg:nxrg) )
-                      ELSE
-                         ALLOCATE( rad_sw_out_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                      ENDIF
-                   ENDIF  
-                   IF ( k == 1 )  THEN
-                      IF ( radiation_scheme == 'clear-sky'  .OR.               &
-                           radiation_scheme == 'constant')  THEN
-                         READ ( 13 )  tmp_3d2
-                         rad_sw_out_av(0:0,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =&
-                             tmp_3d2(0:0,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-                      ELSE
-                         READ ( 13 )  tmp_3d
-                         rad_sw_out_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =&
-                             tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-                      ENDIF
-                   ENDIF
-
-                CASE ( 'rad_sw_cs_hr' )
-                   IF ( .NOT. ALLOCATED( rad_sw_cs_hr ) )  THEN
-                      ALLOCATE( rad_sw_cs_hr(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   ENDIF
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   rad_sw_cs_hr(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =   &
-                           tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'rad_sw_cs_hr_av' )
-                   IF ( .NOT. ALLOCATED( rad_sw_cs_hr_av ) )  THEN
-                      ALLOCATE( rad_sw_cs_hr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   ENDIF
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   rad_sw_cs_hr_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
-                           tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'rad_sw_hr' )
-                   IF ( .NOT. ALLOCATED( rad_sw_hr ) )  THEN
-                      ALLOCATE( rad_sw_hr(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   ENDIF
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   rad_sw_hr(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =      &
-                           tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'rad_sw_hr_av' )
-                   IF ( .NOT. ALLOCATED( rad_sw_hr_av ) )  THEN
-                      ALLOCATE( rad_sw_hr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   ENDIF
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   rad_lw_hr_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =   &
-                           tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-               CASE DEFAULT
-                  WRITE( message_string, * ) 'unknown variable named "',       &
-                                        TRIM( field_char ), '" found in',      &
-                                        '&data from prior run on PE ', myid
-                  CALL message( 'radiation_read_restart_data', 'PA0302', 1, 2, &
-                                0, 6, 0 )
-
-            END SELECT
-
-         ENDDO
-
-         READ ( 13 )  field_char
-
-      ENDDO
-   ENDIF
-
- END SUBROUTINE radiation_read_restart_data
+
+    LOGICAL, INTENT(OUT)  :: found
+
+    REAL(wp), DIMENSION(nys_on_file-nbgp:nyn_on_file+nbgp,nxl_on_file-nbgp:nxr_on_file+nbgp) :: tmp_2d   !< 
+
+    REAL(wp), DIMENSION(nzb:nzt+1,nys_on_file-nbgp:nyn_on_file+nbgp,nxl_on_file-nbgp:nxr_on_file+nbgp) :: tmp_3d   !< 
+
+    REAL(wp), DIMENSION(0:0,nys_on_file-nbgp:nyn_on_file+nbgp,nxl_on_file-nbgp:nxr_on_file+nbgp) :: tmp_3d2   !< 
+
+
+    found = .TRUE.
+
+
+       SELECT CASE ( restart_string(1:length) )
+
+           CASE ( 'rad_net_av' )
+              IF ( .NOT. ALLOCATED( rad_net_av ) )  THEN
+                 ALLOCATE( rad_net_av(nysg:nyng,nxlg:nxrg) )
+              ENDIF  
+              IF ( k == 1 )  READ ( 13 )  tmp_2d
+              rad_net_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  =           &
+                            tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+           CASE ( 'rad_lw_in' )
+              IF ( .NOT. ALLOCATED( rad_lw_in ) )  THEN
+                 IF ( radiation_scheme == 'clear-sky'  .OR.                    &
+                      radiation_scheme == 'constant')  THEN
+                    ALLOCATE( rad_lw_in(0:0,nysg:nyng,nxlg:nxrg) )
+                 ELSE
+                    ALLOCATE( rad_lw_in(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                 ENDIF
+              ENDIF  
+              IF ( k == 1 )  THEN
+                 IF ( radiation_scheme == 'clear-sky'  .OR.                    &
+                      radiation_scheme == 'constant')  THEN
+                    READ ( 13 )  tmp_3d2
+                    rad_lw_in(0:0,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =   &
+                       tmp_3d2(0:0,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                 ELSE
+                    READ ( 13 )  tmp_3d
+                    rad_lw_in(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =     &
+                        tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                 ENDIF
+              ENDIF
+
+           CASE ( 'rad_lw_in_av' )
+              IF ( .NOT. ALLOCATED( rad_lw_in_av ) )  THEN
+                 IF ( radiation_scheme == 'clear-sky'  .OR.                    &
+                      radiation_scheme == 'constant')  THEN
+                    ALLOCATE( rad_lw_in_av(0:0,nysg:nyng,nxlg:nxrg) )
+                 ELSE
+                    ALLOCATE( rad_lw_in_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                 ENDIF
+              ENDIF  
+              IF ( k == 1 )  THEN
+                 IF ( radiation_scheme == 'clear-sky'  .OR.                    &
+                      radiation_scheme == 'constant')  THEN
+                    READ ( 13 )  tmp_3d2
+                    rad_lw_in_av(0:0,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =&
+                        tmp_3d2(0:0,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                 ELSE
+                    READ ( 13 )  tmp_3d
+                    rad_lw_in_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =  &
+                        tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                 ENDIF
+              ENDIF
+
+           CASE ( 'rad_lw_out' )
+              IF ( .NOT. ALLOCATED( rad_lw_out ) )  THEN
+                 IF ( radiation_scheme == 'clear-sky'  .OR.                    &
+                      radiation_scheme == 'constant')  THEN
+                    ALLOCATE( rad_lw_out(0:0,nysg:nyng,nxlg:nxrg) )
+                 ELSE
+                    ALLOCATE( rad_lw_out(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                 ENDIF
+              ENDIF  
+              IF ( k == 1 )  THEN
+                 IF ( radiation_scheme == 'clear-sky'  .OR.                    &
+                      radiation_scheme == 'constant')  THEN
+                    READ ( 13 )  tmp_3d2
+                    rad_lw_out(0:0,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =  &
+                        tmp_3d2(0:0,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                 ELSE
+                    READ ( 13 )  tmp_3d
+                    rad_lw_out(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =    &
+                        tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                 ENDIF
+              ENDIF
+
+           CASE ( 'rad_lw_out_av' )
+              IF ( .NOT. ALLOCATED( rad_lw_out_av ) )  THEN
+                 IF ( radiation_scheme == 'clear-sky'  .OR.                    &
+                      radiation_scheme == 'constant')  THEN
+                    ALLOCATE( rad_lw_out_av(0:0,nysg:nyng,nxlg:nxrg) )
+                 ELSE
+                    ALLOCATE( rad_lw_out_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                 ENDIF
+              ENDIF  
+              IF ( k == 1 )  THEN
+                 IF ( radiation_scheme == 'clear-sky'  .OR.                    &
+                      radiation_scheme == 'constant')  THEN
+                    READ ( 13 )  tmp_3d2
+                    rad_lw_out_av(0:0,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) &
+                       = tmp_3d2(0:0,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                 ELSE
+                    READ ( 13 )  tmp_3d
+                    rad_lw_out_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                        tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                 ENDIF
+              ENDIF
+
+           CASE ( 'rad_lw_cs_hr' )
+              IF ( .NOT. ALLOCATED( rad_lw_cs_hr ) )  THEN
+                 ALLOCATE( rad_lw_cs_hr(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+              ENDIF
+              IF ( k == 1 )  READ ( 13 )  tmp_3d
+              rad_lw_cs_hr(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =        &
+                      tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+           CASE ( 'rad_lw_cs_hr_av' )
+              IF ( .NOT. ALLOCATED( rad_lw_cs_hr_av ) )  THEN
+                 ALLOCATE( rad_lw_cs_hr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+              ENDIF
+              IF ( k == 1 )  READ ( 13 )  tmp_3d
+              rad_lw_cs_hr_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =     &
+                      tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+           CASE ( 'rad_lw_hr' )
+              IF ( .NOT. ALLOCATED( rad_lw_hr ) )  THEN
+                 ALLOCATE( rad_lw_hr(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+              ENDIF
+              IF ( k == 1 )  READ ( 13 )  tmp_3d
+              rad_lw_hr(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =           &
+                      tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+           CASE ( 'rad_lw_hr_av' )
+              IF ( .NOT. ALLOCATED( rad_lw_hr_av ) )  THEN
+                 ALLOCATE( rad_lw_hr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+              ENDIF
+              IF ( k == 1 )  READ ( 13 )  tmp_3d
+              rad_lw_hr_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =        &
+                      tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+           CASE ( 'rad_sw_in' )
+              IF ( .NOT. ALLOCATED( rad_sw_in ) )  THEN
+                 IF ( radiation_scheme == 'clear-sky'  .OR.                    &
+                      radiation_scheme == 'constant')  THEN
+                    ALLOCATE( rad_sw_in(0:0,nysg:nyng,nxlg:nxrg) )
+                 ELSE
+                    ALLOCATE( rad_sw_in(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                 ENDIF
+              ENDIF  
+              IF ( k == 1 )  THEN
+                 IF ( radiation_scheme == 'clear-sky'  .OR.                    &
+                      radiation_scheme == 'constant')  THEN
+                    READ ( 13 )  tmp_3d2
+                    rad_sw_in(0:0,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =   &
+                        tmp_3d2(0:0,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                 ELSE
+                    READ ( 13 )  tmp_3d
+                    rad_sw_in(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =     &
+                        tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                 ENDIF
+              ENDIF
+
+           CASE ( 'rad_sw_in_av' )
+              IF ( .NOT. ALLOCATED( rad_sw_in_av ) )  THEN
+                 IF ( radiation_scheme == 'clear-sky'  .OR.                    &
+                      radiation_scheme == 'constant')  THEN
+                    ALLOCATE( rad_sw_in_av(0:0,nysg:nyng,nxlg:nxrg) )
+                 ELSE
+                    ALLOCATE( rad_sw_in_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                 ENDIF
+              ENDIF  
+              IF ( k == 1 )  THEN
+                 IF ( radiation_scheme == 'clear-sky'  .OR.                    &
+                      radiation_scheme == 'constant')  THEN
+                    READ ( 13 )  tmp_3d2
+                    rad_sw_in_av(0:0,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =&
+                        tmp_3d2(0:0,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                 ELSE
+                    READ ( 13 )  tmp_3d
+                    rad_sw_in_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =  &
+                        tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                 ENDIF
+              ENDIF
+
+           CASE ( 'rad_sw_out' )
+              IF ( .NOT. ALLOCATED( rad_sw_out ) )  THEN
+                 IF ( radiation_scheme == 'clear-sky'  .OR.                    &
+                      radiation_scheme == 'constant')  THEN
+                    ALLOCATE( rad_sw_out(0:0,nysg:nyng,nxlg:nxrg) )
+                 ELSE
+                    ALLOCATE( rad_sw_out(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                 ENDIF
+              ENDIF  
+              IF ( k == 1 )  THEN
+                 IF ( radiation_scheme == 'clear-sky'  .OR.                    &
+                      radiation_scheme == 'constant')  THEN
+                    READ ( 13 )  tmp_3d2
+                    rad_sw_out(0:0,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =  &
+                        tmp_3d2(0:0,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                 ELSE
+                    READ ( 13 )  tmp_3d
+                    rad_sw_out(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =    &
+                        tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                 ENDIF
+              ENDIF
+
+           CASE ( 'rad_sw_out_av' )
+              IF ( .NOT. ALLOCATED( rad_sw_out_av ) )  THEN
+                 IF ( radiation_scheme == 'clear-sky'  .OR.                    &
+                      radiation_scheme == 'constant')  THEN
+                    ALLOCATE( rad_sw_out_av(0:0,nysg:nyng,nxlg:nxrg) )
+                 ELSE
+                    ALLOCATE( rad_sw_out_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                 ENDIF
+              ENDIF  
+              IF ( k == 1 )  THEN
+                 IF ( radiation_scheme == 'clear-sky'  .OR.                    &
+                      radiation_scheme == 'constant')  THEN
+                    READ ( 13 )  tmp_3d2
+                    rad_sw_out_av(0:0,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) &
+                       = tmp_3d2(0:0,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                 ELSE
+                    READ ( 13 )  tmp_3d
+                    rad_sw_out_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                        tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                 ENDIF
+              ENDIF
+
+           CASE ( 'rad_sw_cs_hr' )
+              IF ( .NOT. ALLOCATED( rad_sw_cs_hr ) )  THEN
+                 ALLOCATE( rad_sw_cs_hr(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+              ENDIF
+              IF ( k == 1 )  READ ( 13 )  tmp_3d
+              rad_sw_cs_hr(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =        &
+                      tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+           CASE ( 'rad_sw_cs_hr_av' )
+              IF ( .NOT. ALLOCATED( rad_sw_cs_hr_av ) )  THEN
+                 ALLOCATE( rad_sw_cs_hr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+              ENDIF
+              IF ( k == 1 )  READ ( 13 )  tmp_3d
+              rad_sw_cs_hr_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =     &
+                      tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+           CASE ( 'rad_sw_hr' )
+              IF ( .NOT. ALLOCATED( rad_sw_hr ) )  THEN
+                 ALLOCATE( rad_sw_hr(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+              ENDIF
+              IF ( k == 1 )  READ ( 13 )  tmp_3d
+              rad_sw_hr(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =           &
+                      tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+           CASE ( 'rad_sw_hr_av' )
+              IF ( .NOT. ALLOCATED( rad_sw_hr_av ) )  THEN
+                 ALLOCATE( rad_sw_hr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+              ENDIF
+              IF ( k == 1 )  READ ( 13 )  tmp_3d
+              rad_lw_hr_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =        &
+                      tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+           CASE DEFAULT
+
+              found = .FALSE.
+
+       END SELECT
+
+
+ END SUBROUTINE radiation_rrd_local
 
 
